config/routes.rb
Rails.application.routes.draw do

  
  resources :projects do
    resources :tickets do
      member do
        put :change
      end
      resources :timelogs
      resources :checkboxes do
        member do 
          patch :complete
        end 
      end
      resources :comments
    end
  end
  resources :lists do 
    resources :tasks do
      member do 
        put :change
        put :complete
      end
    end
  end 
  
  get 'pages/home'
  get 'about' => 'pages#about'
  get 'peoples' => 'pages#peoples'

  root 'projects#index'
  devise_for :users, :controllers => { registrations: 'registrations' }

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/list.rb
class List < ApplicationRecord
	has_many :tasks
	belongs_to :user

	accepts_nested_attributes_for :tasks
	validates :user_id, presence: true

end

app/controllers/lists_controller.rb
class ListsController < ApplicationController
  before_action :set_list, only: [:show, :edit, :update, :destroy]
  helper_method :last_update
  # GET /lists
  # GET /lists.json
  def index
    @doing ||= []
    @lists.each do |l|
      l.tasks.where(state: "doing").each do |d|
        @doing << d
      end 
    end

  end

  # GET /lists/1
  # GET /lists/1.json
  def show
    @list = @list = List.find(params[:id])
    @todo = @list.tasks.where(state: "to_do")
    @doing = @list.tasks.where(state: "doing")
    @done = @list.tasks.where(state: "done")

  end

  # GET /lists/new
  def new
    @list = List.new
    @list.tasks.build
  end

  # GET /lists/1/edit
  def edit
  end

  # POST /lists
  # POST /lists.json
  def create
    @list = List.new(list_params)
    @list.user_id = current_user.id if current_user
    respond_to do |format|
      if @list.save
        format.html { redirect_to @list, falsh: 'List was successfully created.' }
        format.json { render :show, status: :created, location: @list }
      else
        format.html { render :new }
        format.json { render json: @list.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /lists/1
  # PATCH/PUT /lists/1.json
  def update
    respond_to do |format|
      if @list.update(list_params)
        format.html { redirect_to @list, notice: 'List was successfully updated.' }
        format.json { render :show, status: :ok, location: @list }
      else
        format.html { render :edit }
        format.json { render json: @list.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /lists/1
  # DELETE /lists/1.json
  def destroy
    @list.destroy
    respond_to do |format|
      format.html { redirect_to lists_url, notice: 'List was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_list
      @list = List.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def list_params
      params.require(:list).permit(:name, :description, :id)
    end


end

app/helpers/lists_helper.rb
module ListsHelper

end

app/views/lists/_form.html.erb
<%= simple_form_for(@list) do |f| %>
  <%= f.error_notification %>

  <div class="form-inputs">
    <%= f.input :name %>
    <%= f.input :description %>
  </div>

  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %>

app/views/lists/_task.html.erb
  <% if task.state == "to_do" %>
    <div class="card card-outline-primary">
  <% elsif task.state == "doing" %>
    <div class="card card-outline-warning">
  <%else %>
    <div class="card card-outline-success">
  <% end %>

    <div class="card-header text-muted">
    created in <%= time_ago_in_words(task.created_at)%> ago
    <div class="btn-group pull-right">
    <%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_list_task_path(@list, task), class: "btn btn-secondary btn-sm" %>  
    <%= link_to "<i class='fa fa-times'></i>".html_safe, list_task_path(@list, task), method: :delete, data: {confirm: "Are you sure?" }, class: "btn btn-secondary btn-sm" %>  
    </div>
    </div>
      <div class="card-block ">
    <%= raw(task.content_html)%>

    </div>

  
  <div class="card-footer text-muted">

    updated <%= time_ago_in_words(task.updated_at)%> ago  
    <% if task.state == "doing" %>
    <div class="btn-group btn-group-justified pull-right btn-sm">
    <%= link_to "&nbsp;<i class='fa fa-angle-left'></i>&nbsp;".html_safe, change_list_task_path(@list,task,state: "to_do"), method: :put, class:"btn btn-warning inline-button btn-sm" %>  
    <%= link_to "&nbsp;<i class='fa fa-angle-right'></i>&nbsp;".html_safe, change_list_task_path(@list,task,state: "done"), method: :put, class:"btn btn-success inline-button btn-sm" %>
    </div>
    <% elsif task.state == "to_do" %>
    <%= link_to "&nbsp;<i class='fa fa-angle-right'></i>&nbsp;".html_safe, change_list_task_path(@list,task,state: "doing"), method: :put, class:"btn btn-success inline-button pull-right btn-sm"  %>
    <% else %>
        <%= link_to "&nbsp;<i class='fa fa-angle-left'></i>&nbsp;".html_safe, change_list_task_path(@list,task,state: "doing"), method: :put,class:"btn btn-danger inline-button pull-right btn-sm" %>
    <% end %>        
  </div>
</div>
<br>

app/views/lists/edit.html.erb
<h1>Editing List</h1>

<%= render 'form', list: @list %>

<%= link_to 'Show', @list %> |
<%= link_to 'Back', lists_path %>

app/views/lists/index.html.erb
<p id="notice"><%= notice %></p>
<nav class="breadcrumb">
  <%= link_to "Home", root_path, class: "breadcrumb-item"%>
  <%= link_to "Lists", lists_path, class: "breadcrumb-item" %>
  <span class="breadcrumb-item active">All</span>
</nav>
<% if @doing.try(:any?) %>
<h2>Current in Doing</h2>
<br>
  <table id="sorttable" class="table table-bordered table-striped tableserter">
    <thead>
    <tr>
      <th>#</th>
      <th>TO-DO</th>
      <th>Created</th>
      <th>Last edit</th>
      <th class="sorter-false" colspan="2"></th>

    </tr>
    </thead>
    <tbody>
      <% @doing.each do |task| %>
      <tr>
        <th> <%=task.id %> </th>
        <td> <%= task.content %></td>
        <td> <%= time_ago_in_words(task.created_at) %> ago </td>
        <td> <%= time_ago_in_words(task.updated_at) %> </td> 
        <td> <%= link_to "&nbsp;<i class='fa fa-check'></i>&nbsp;done".html_safe, complete_list_task_path(task.list_id,task,state: "done"), method: :put %> </td>
        <td><%= link_to "&nbsp;<i class='fa fa-eye'></i>&nbsp;view".html_safe, list_path(task.list_id) %></td>
      </tr>
      <% end %>
    </tbody>
  </table>
<% end %> 


<br>
<h2>Lists <%= link_to "<i class='fa fa-plus-circle text-success'></i>".html_safe, new_list_path %> </h2>

<table  class="table table-bordered table-striped">
  <thead>
  <tr>
      <th>ID</th>
      <th>Name</th>
      <th>Description</th>
      <th>TBD / Done</th>
      <th>Last Update</th>
      <th colspan="4"></th>
    </tr>
  </thead>

  <tbody>
    <% @lists.each_with_index do |list, index| %>
      <tr>
        <td><%= list.id %>&nbsp;&nbsp;<a href=""><i class='fa fa-hand-o-down' data-toggle="collapse" data-target="#tbd_tasks<%=index.to_s%>"></i></a>
        </td>
        <td><%= list.name %></td>
        <td><%= list.description %></td>
        <td><%= list.tasks.where(state: "to_do").count %> / <%= list.tasks.count %> </td>
        <td> 
        <% if list.tasks.try(:any?) %>
        <%= time_ago_in_words(list.tasks.maximum('updated_at'))%> 
        <%else %>
        <%= time_ago_in_words(list.updated_at) %>
        <%end%>
        </td>
        <td> <%= link_to "<i class='fa fa-plus'></i>".html_safe, new_list_task_path(list)%> </td>
        <td><%= link_to "<i class='fa fa-eye'></i>".html_safe, list %></td>
        <td><%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_list_path(list) %></td>
        <td><%= link_to "<i class='fa fa-times'></i>".html_safe, list, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
      <tr id="tbd_tasks<%= index.to_s%>" class="collapse out">
        <td>
        </td>
        <td>
          <div>
            <ul>
              <li> <%= list.tasks.count %> total </li>
              <li><%=list.tasks.where(state: "to_do").count%> tasks to-do</li>
              <li><%=list.tasks.where(state: "doing").count%> in doing</li>
              <li><%=list.tasks.where(state: "done").count%> done</li>
            </ul>
          </div>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/lists/new.html.erb
<h1>New List</h1>

<%= render 'form', list: @list %>

<%= link_to 'Back', lists_path %>

app/views/lists/show.html.erb
<p id="notice"><%= notice %></p>
<nav class="breadcrumb">
  <%= link_to "Home", root_path, class: "breadcrumb-item"%>
  <%= link_to "Lists", lists_path, class: "breadcrumb-item" %>
  <span class="breadcrumb-item active"> <%= @list.name %> </span>
</nav>
<h1 class="text-center"> <%= @list.name %> <br> <small class="text-muted"><%= @list.description %></small> </h1><br>


<div class="row">
  <div class="col-md-4"><h2 class="text-center">To Do <%= link_to "<i class='fa fa-plus-circle text-success'></i>".html_safe, new_list_task_path(@list) %> </h1>
  <%= render :partial => 'task', :collection => @todo %>

  </div>
  <div class="col-md-4"><h2 class="text-center">Doing</h1>
  <%= render :partial => 'task', :collection => @doing %>

  </div>
  <div class="col-md-4"><h2 class="text-center">Done</h1>
  <%= render :partial => 'task', :collection => @done %>
</div>
</div>
<br>

<%= link_to 'Add task', new_list_task_path(@list) %> |
<%= link_to 'Edit', edit_list_path(@list) %> |
<%= link_to 'Back', lists_path %>